<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加公司',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #timeSlot="{ item }">
          {{ item.startDate }} - {{ item.stopDate }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加公司' : '编辑公司'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
        <template #timeGange>
          <el-date-picker
            v-model="formData.data.timeArr"
            type="daterange"
            unlink-panels
            range-separator="To"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
            value-format="YYYY-MM-DD"
          />
        </template>
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import useUserStore from "@/store/modules/user";
import { computed, defineComponent, ref } from "vue";
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  name: [{ required: true, message: "请输入公司名称", trigger: "blur" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = [];
const config = computed(() => {
  return [
    {
      attrs: {
        label: "公司名称",
        prop: "name",
      },
    },
    {
      attrs: {
        label: "英文名",
        prop: "nameEn",
      },
    },
    {
      attrs: {
        label: "企业类型",
        prop: "type",
      },
      render(type) {
        return proxy.dictDataEcho(type, enterpriseType.value);
      },
    },
    {
      attrs: {
        label: "统一社会信用代码",
        prop: "uscCode",
      },
    },
    {
      attrs: {
        label: "法定代表人",
        prop: "legalPersonName",
      },
    },
    {
      attrs: {
        label: "注册资本",
        prop: "registeredCapital",
      },
    },
    {
      attrs: {
        type: "slot",
        slot: "timeSlot",
        label: "营业期限",
      },
    },
    {
      attrs: {
        label: "纳税人资质",
        prop: "taxpayerQualification",
      },
      render(type) {
        return proxy.dictDataEcho(type, contactInformationType.value);
      },
    },
    {
      attrs: {
        label: "进出口企业代码",
        prop: "iaeeCode",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                // 删除
                proxy
                  .post("/corporation/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {
    type: "1",
  },
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = reactive([
  {
    type: "input",
    prop: "name",
    label: "公司名称",
    required: true,
  },
  {
    type: "input",
    prop: "nameEn",
    label: "英文名",
  },
  {
    type: "select",
    prop: "type",
    label: "企业类型",
  },
  {
    type: "input",
    prop: "uscCode",
    label: "统一社会信用代码",
  },
  {
    type: "input",
    prop: "legalPersonName",
    label: "法定代表人",
  },
  {
    type: "input",
    prop: "registeredCapital",
    label: "注册资本",
  },
  {
    type: "slot",
    slotName: "timeGange",
    prop: "startDate",
    label: "营业期限",
  },
  {
    type: "select",
    prop: "taxpayerQualification",
    label: "纳税人资质",
    data: [],
    //   isLoad: {
    //   url: "/dictTenantData/page",
    //   labelKey: "dictValue",
    //   labelVal: "dictKey",
    //   method: "post",
    //   req: {
    //     pageNum: 1,
    //     pageSize: 999,
    //     dictCode: "customer_source",
    //     tenantId: useUserStore().user.tenantId,
    //   },
    //   resUrl: "rows",
    // },
  },
  {
    type: "input",
    prop: "iaeeCode",
    label: "进出口企业代码",
    required: true,
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/corporation/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {
    timeArr: [],
  };
};
const selection = ref({
  data: [],
});
const select = (_selection, row) => {
  selection.value.data = _selection;
  console.log(_selection.length);
};
const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    if (formData.data.timeArr.length > 0) {
      formData.data.startDate = formData.data.timeArr[0];
      formData.data.stopDate = formData.data.timeArr[1];
    }
    submitLoading.value = true;
    proxy.post("/corporation/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  dialogVisible.value = true;
  modalType.value = "edit";
  proxy.post("/corporation/detail", { id: row.id }).then((res) => {
    res.timeArr = [res.startDate, res.stopDate];
    res.type = res.type + "";
    res.taxpayerQualification = res.taxpayerQualification + "";
    formData.data = res;
    console.log(formData.data.timeArr, "ws");
  });
};

const enterpriseType = ref([]);
const contactInformationType = ref([]);

const getDict = () => {
  const tenantId = useUserStore().user.tenantId;
  proxy
    .post("/dictTenantData/page", {
      pageNum: 1,
      pageSize: 999,
      tenantId: tenantId,
      dictCode: "enterprise_type",
    })
    .then((res) => {
      formConfig[2].data = res.rows.map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      enterpriseType.value = res.rows;
    });

  proxy
    .post("/dictTenantData/page", {
      pageNum: 1,
      pageSize: 999,
      tenantId: tenantId,
      dictCode: "taxpayer_qualification",
    })
    .then((res) => {
      formConfig[7].data = res.rows.map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      contactInformationType.value = res.rows;
    });
};

getList();
getDict();
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>